<template>
  <div>
    <h1 class="text-2xl text-purple-600 pb-3">Sucursales</h1>
    <h1 v-if="loading" class="text-2xl text-red-400">...Cargando</h1>
    <appTable v-else :headers="headers">
      <template #body>
        <locationCard
          v-for="location in locationList"
          :key="location.id"
          :location="location"
          @click:users="handleShowUsers"
        ></locationCard>
      </template>
    </appTable>

    <appDialog v-model="dialog">
      <template #text>
        <userProfile
          v-for="user in dialogUserList"
          :key="user.id"
          :user="user"
        ></userProfile>
      </template>
    </appDialog>
  </div>
</template>

<script>
import apiMixin from '../mixins/api';
import constants from '../constants';
import locationCard from '../components/location/card';
import userProfile from '../components/user/profile';
export default {
  mixins: [apiMixin],
  components: { locationCard, userProfile },
  data: () => ({
    loading: false,
    dialog: false,
    headers: constants.LocationHeaderTable,
    dialogUserList: [],
  }),
  async mounted() {
    this.loading = true;
    if (this.locationList.length === 0) {
      await this.fetchLocationListAction();
    }
    if (this.userList.length === 0) {
      await this.fetchUserListAction();
    }
    this.loading = false;
  },
  methods: {
    handleShowUsers(userList) {
      this.dialog = true;
      this.dialogUserList = [...userList].sort((a, b) =>
        a.firstName > b.firstName ? 1 : b.firstName > a.firstName ? -1 : 0
      );
    },
  },
};
</script>
